package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.model.entity.StrategiPengadaan;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.StrategiPengadaanRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/strategipengadaan")
public class StrategiPengadaanController {
        @Autowired
        private StrategiPengadaanRepository strategipengadaanRepository;

        //get all data
        @GetMapping
        public List<StrategiPengadaan> getAllstrategipengadaans(){
            return strategipengadaanRepository.findAll();
        }

        // create
        @PostMapping
        public StrategiPengadaan createStrategipengadaan(@RequestBody StrategiPengadaan strategipengadaan) {
            return strategipengadaanRepository.save(strategipengadaan);
        }

        // get strategipengadaan by id rest api
        @GetMapping("/{id}")
        public ResponseEntity<StrategiPengadaan> getStrategipengadaanById(@PathVariable Long id) {
            StrategiPengadaan strategipengadaan = strategipengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Strategipengadaan not exist with id :" + id));
            return ResponseEntity.ok(strategipengadaan);
        }

        // update strategipengadaan rest api
        @PutMapping("/{id}")
        public ResponseEntity<StrategiPengadaan> updateStrategipengadaan(@PathVariable Long id, @RequestBody StrategiPengadaan strategiPengadaanDetails){
            StrategiPengadaan strategipengadaan = strategipengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Strategipengadaan not exist with id :" + id));

            strategipengadaan.setStrategiPengadaan(strategiPengadaanDetails.getStrategiPengadaan());
            strategipengadaan.setKeterangan(strategiPengadaanDetails.getKeterangan());

            StrategiPengadaan updatedStrategiPengadaan =  strategipengadaanRepository.save(strategipengadaan);
            return ResponseEntity.ok(updatedStrategiPengadaan);
        }

        // delete strategipengadaan rest api
        @DeleteMapping("/{id}")
        public ResponseEntity<Map<String, Boolean>> deleteStrategipengadaan(@PathVariable Long id){
            StrategiPengadaan strategipengadaan = strategipengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Strategipengadaan not exist with id :" + id));

            strategipengadaanRepository.delete(strategipengadaan);
            Map<String, Boolean> response = new HashMap<>();
            response.put("deleted", Boolean.TRUE);
            return ResponseEntity.ok(response);
        }




}
