package com.iconplus.smartproc.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.model.entity.UnitInisiator;
import com.iconplus.smartproc.repository.UnitInisiatorRepository;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/unitinisiator")
public class UnitInisiatorController {
    @Autowired
    private UnitInisiatorRepository unitinisiatorRepository;

    //get all data
    @GetMapping
    public List<UnitInisiator> getAllUnitinisiator(){
        return unitinisiatorRepository.findAll();
    }

    // create
    @PostMapping
    public UnitInisiator createUnitinisiator(@RequestBody UnitInisiator unitinisiator) {
        return unitinisiatorRepository.save(unitinisiator);
    }

    // get unitinisiator by id rest api
    @GetMapping("/{id}")
    public ResponseEntity<UnitInisiator> getUnitinisiatorById(@PathVariable Long id) {
        UnitInisiator unitinisiator = unitinisiatorRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Unitinisiator not exist with id :" + id));
        return ResponseEntity.ok(unitinisiator);
    }

    // update jenispengadaan rest api
    @PutMapping("/{id}")
    public ResponseEntity<UnitInisiator> updateUnitinisiator(@PathVariable Long id, @RequestBody UnitInisiator unitInisiatorDetails){
        UnitInisiator unitinisiator = unitinisiatorRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Unitinisiator not exist with id :" + id));

        unitinisiator.setUnitInisiator(unitInisiatorDetails.getUnitInisiator());
        unitinisiator.setKeterangan(unitInisiatorDetails.getKeterangan());

        UnitInisiator updatedUnitInisiator = unitinisiatorRepository.save(unitinisiator);
        return ResponseEntity.ok(updatedUnitInisiator);
    }

    // delete jenispengadaan rest api
    @DeleteMapping("/{id}")
    public ResponseEntity<Map<String, Boolean>> deleteUnitinisiator(@PathVariable Long id){
        UnitInisiator unitinisiator = unitinisiatorRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Unit inisiator not exist with id :" + id));

        unitinisiatorRepository.delete(unitinisiator);
        Map<String, Boolean> response = new HashMap<>();
        response.put("deleted", Boolean.TRUE);
        return ResponseEntity.ok(response);
    }
}
