package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.model.entity.Users;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.UsersRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/users")
public class UsersController {
	@Autowired
	private UsersRepository usersRepository;

	//get all data
	@GetMapping
	public List<Users> getAllUserss(){
		return usersRepository.findAll();
	}

	// create
	@PostMapping
	public Users createUsers(@RequestBody Users users) {
		return usersRepository.save(users);
	}

	// get users by id rest api
	@GetMapping("/{id}")
	public ResponseEntity<Users> getUsersById(@PathVariable Long id) {
		Users users = usersRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Users not exist with id :" + id));
		return ResponseEntity.ok(users);
	}

	// update users rest api
	@PutMapping("/{id}")
	public ResponseEntity<Users> updateUsers(@PathVariable Long id, @RequestBody Users usersDetails){
		Users users = usersRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Users not exist with id :" + id));

		users.setUsername(usersDetails.getUsername());
		users.setFullname(usersDetails.getFullname());
		users.setEmail(usersDetails.getEmail());
		users.setPassword(usersDetails.getPassword());
//		users.setInstansi(usersDetails.getInstansi());
//		users.setBidang(usersDetails.getBidang());
//		users.setJabatan(usersDetails.getJabatan());
//		users.setRole(usersDetails.getRole());

		Users updatedUsers = usersRepository.save(users);
		return ResponseEntity.ok(updatedUsers);
	}

	// delete users rest api
	@DeleteMapping("/{id}")
	public ResponseEntity<Map<String, Boolean>> deleteUsers(@PathVariable Long id){
		Users users = usersRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Users not exist with id :" + id));

		usersRepository.delete(users);
		Map<String, Boolean> response = new HashMap<>();
		response.put("deleted", Boolean.TRUE);
		return ResponseEntity.ok(response);
	}
}