package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.Roles;
import com.iconplus.smartproc.model.projection.UserRoleView;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface RolesRepository extends JpaRepository<Roles, Long> {

    @Query(value = "SELECT u.id as id, " +
            "u.username as username, " +
            "u.password as password, " +
            "u.roleId as roleId, " +
            "r.role as role " +
            "FROM Users u " +
            "join Roles r on r.id=u.roleId " +
            "WHERE u.deleted = false " +
            "AND r.deleted = false " +
            "AND u.username = :userName ")
    Optional<UserRoleView> getUserRoleByUserId(String userName);
    
}
