package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.TokenManagement;
import com.iconplus.smartproc.model.projection.TokenManagementView;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface TokenManagementRepository extends JpaRepository<TokenManagement, String> {

    @Query(value = "SELECT access_token as accessToken FROM token_management " +
            "WHERE user_id = :userId " +
            "AND deleted = false " +
            "AND expired_time >= SYSDATE", nativeQuery = true)
    List<TokenManagementView> findAccessTokenByUserIdAndDeletedFalse(String userId);
}
